﻿
#version 330 core

smooth in vec2 texCoord;
smooth in vec3 varyinglightDir;
smooth in vec3 normal; 
smooth in vec4 SM_tex_coord;

uniform sampler2D texSampler2D;
uniform sampler2D shadow_map; // shadow map is just a texture

uniform vec4 ambientColor;
uniform vec4 diffuseColor;
uniform vec4 specColor;

out vec4 fragColor;

void main(void) {
	
	
	vec3 tex_coords = SM_tex_coord.xyz/SM_tex_coord.w;
	
	float diff = max(0.0, dot(normalize(normal),normalize(varyinglightDir)));

	fragColor = diff* diffuseColor;

	fragColor += ambientColor;

	fragColor *= texture2D(texSampler2D,texCoord) ; 

	vec3 vertReflection = normalize(reflect(-normalize(varyinglightDir),normalize(normal)));

	float spec = max(0.0, dot(normalize(normal), vertReflection));

	/*if(diff !=0){
		float fspec = pow(spec,128.0);
		
		//fragColor.rgb +=vec3(fspec,fspec,fspec);
		
	}*/

	float depth = texture(shadow_map, tex_coords.xy).r;
	
	float inShadow = (depth < tex_coords.z) ? 1.0 : 0.0;

	if(inShadow == 1){
		fragColor *= 0.5;
	}

	
}