#version 330 core


smooth in vec2 texCoord;
smooth in vec3 varyinglightDir;
smooth in vec3 normal; 



uniform sampler2D texSampler2D;


uniform vec4 ambientColor;
uniform vec4 diffuseColor;
uniform vec4 specColor;

out vec4 fragColor;

void main(void)
{
	
	//float shadow = textureProj(shadow_map, SM_tex_coord);

	float diff = max(0.0, dot(normalize(normal),normalize(varyinglightDir)));

	fragColor = diff* diffuseColor;

	fragColor += ambientColor;

	fragColor *= texture2D(texSampler2D,texCoord); 
	
	vec3 vertReflection = normalize(reflect(-normalize(varyinglightDir),normalize(normal)));

	float spec = max(0.0, dot(normalize(normal), vertReflection));

	if(diff !=0){
		float fspec = pow(spec,64.0);
		fragColor.rgb +=vec3(fspec,fspec,fspec);
	}

}
