#version 330 core

in vec4 vertexPosition;
in vec2 vertexTexCoord;
in vec3 vertexNormal;

uniform vec3 lightPosition;
uniform mat4 mvMatrix;
uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 tex_mat;
uniform mat3 normalMatrix; 

smooth out vec2 texCoord;
smooth out vec3 normal;
smooth out vec3 varyinglightDir;


void main(void)
{

	normal =normalMatrix*vertexNormal;
	vec4 vertPosition4 =  mvMatrix*vertexPosition;
	vec3 vertPosition3 = vertPosition4.xyz/ vertPosition4.w;

	varyinglightDir = normalize(lightPosition - vertPosition3);

	texCoord = vertexTexCoord;
	gl_Position = projectionMatrix* mvMatrix* vertexPosition;
	
}

